class BinomialTree<T extends Comparable<T>> 
    implements Comparable<BinomialTree<T>>
{

    /************************************************/

    private int order;

    /************************************************/

    private T data;

    /************************************************/

    private LinkedList<BinomialTree<T>> sons;
    
    /************************************************/

    public BinomialTree(T data)
    {
	this.data = data;
	order = 0;
	sons = null;
    }

    /************************************************/

    public BinomialTree<T> fusion(BinomialTree<T> other) 
    {
	if (getData().compareTo(other.getData()) > 0)
	    return other.fusion(this);
	if (order != other.getOrder())
	    System.out.println("Invalid arguments");
	sons = (sons == null) ? 
	    new LinkedList<BinomialTree<T>>(other) : 
	    sons.addFront(other); 
	order++;
	return this;
    }

    /************************************************/

    public int getOrder()
    {
	return order;
    }
    
    /************************************************/

    public T getData()
    {
	return data;
    }
    
    /************************************************/

    public BinomialHeap<T> extractSons()
    {
	return new BinomialHeap<T>((sons == null) ? 
				null : 
				sons.reverse()
				);
    }
        
    /************************************************/

    public int compareTo(BinomialTree<T> other)
    {
	if (order < other.getOrder())
	    return -1;
	if (order == other.getOrder())
	    return 0;
	return 1;
    }
}