#ifndef COMPLEXE_H
#define COMPLEXE_H

#include"linkedList.h"

/*
  Type complexe
 */

typedef struct
{
  /*
    Partie reelle
  */
  double re;

  /*
    partie imaginaire
  */
  double im;
  
  /*
    module
   */
  double mod;

  /*
    argument, nul si le nombre est 0 + 0i
   */
  double arg;
}complexe, *pComplexe;


double reComplexe(complexe c);

/*
  Retourne la partie imaginaire
 */
double imComplexe(complexe c);

/*
  Retourne le module
 */
double modComplexe(complexe c);

/*
  Retourne l'argument
 */
double argComplexe(complexe c);

/*
  Affiche c sous forme exponentielle
 */
void printExpComplexe(complexe c);

/*
  Affiche l'affixe de c
 */
void printAffComplexe(complexe c);

/*
  Cree un complexe a partir de son affixe
 */
complexe makeAffComplexe(double re, double im);

/*
  Cree un complexe a partir de sa forme exponentielle
 */
complexe makeExpComplexe(double mod, double arg);

/*
  Retourne le conjugue de c
 */
complexe conjugueComplexe(complexe c);

/*
  Soustrait c1 et c2
 */
complexe subComplexe(complexe c1, complexe c2);

/*
  Additionne c1 et c2
 */
complexe addComplexe(complexe c1, complexe c2);

/*
  Multiplie c1 et c2
 */
complexe multComplexe(complexe c1, complexe c2);

/*
  Multiplie  c par le reel d
 */
complexe multReelComplexe(double d, complexe c);

/*
  Divise c2 par c1
 */
complexe divComplexe(complexe c1, complexe c2);

/*
  Eleve c a la puissance n
 */
complexe puissComplexe(complexe c, unsigned long n);

/*
  Retourne un pointeur vers une copie du complexe c.
*/
pComplexe copyComplexe(complexe c);

#endif
