#ifndef FOURIER_H
#define FOURIER_H

#include"linkedList.h"
#include"complexe.h"

/*
  Retourne la transformee discrete de Fourier du vecteur l. 
  Algorithme iteratif en O(n^2).
 */
linkedList* transformeeFourierIt(linkedList* l);

/*
  Retourne la transformee discrete de Fourier inverse 
  du vecteur l. Algorithme iteratif en O(n^2).
 */
linkedList* transformeeInverseFourierIt(linkedList* l);

/*
  Retourne la transformee discrete de Fourier du vecteur l, de taille 
  n = 2^m. Algorithme recursif en O(n log n).
 */
linkedList* FFT(linkedList* l);

/*
  Retourne la transformee discrete de Fourier inverse 
  du vecteur l de taille n = 2^m. Algorithme recursif en
  O(n log n).
 */
linkedList* inverseFFT(linkedList* l);

#endif
