#include"stackTree.h"

/***********************************************************/

stackTree* createST(sTree* s, stackTree* next)
{
  stackTree* st = (stackTree*)malloc(sizeof(stackTree));
  if (st == NULL)
    {
      printf("no memory left...\n");
      exit(0);
    }
  st->s = s;
  st->next = next;
  return st;
  }

/***********************************************************/

void printST(stackTree* st)
{
  if (st != NULL)
    {
      printST(st->next);
      printf("->");
      printSTree(st->s);
    }
}

/***********************************************************/

/*ne detruit pas les arbres*/

void destroyST(stackTree* st)
{
  if (st != NULL)
    {
      destroyST(st->next);
      free(st);
    }
}

/***********************************************************/

int isEmptyST(stackTree* st)
{
  return st == NULL;
}

/***********************************************************/

stackTree* pushST(stackTree* st, sTree* s) 
{
  return createST(s, st);
}

/***********************************************************/

sTree* topST(stackTree* st)
{
  if (isEmptyST(st))
    {
      printf("Empty stack has no top.\n");
      exit(0);      
    }
  return st->s;
}

/***********************************************************/

stackTree* popST(stackTree* st)
{
  if (isEmptyST(st))
    {
      printf("Can't pop empty stack.\n");
      exit(0);      
    }
  stackTree* next = st->next;
  st->next = NULL;
  destroyST(st);
  return next;
}

/***********************************************************/

stackTree* addConstantST(stackTree* st, int constant)
{
  return pushST(st, createConstantSTree(constant));
}

/***********************************************************/

stackTree* addVariableST(stackTree* st)
{
  return pushST(st, createVariableSTree());
}

/***********************************************************/

stackTree* addOperatorST(stackTree* st, int operator)
{
  sTree* left, *right;
  right = topST(st);
  st = popST(st);
  left = topST(st);
  st = popST(st);
  return pushST(st, createOperatorSTree(operator, left, right));
}

/***********************************************************/

stackTree* addLnST(stackTree* st, int operator)
{
  sTree* arg;
  arg = topST(st);
  st = popST(st);
  return pushST(st, createLnSTree(arg));
}

