#ifndef STACK_TREE_H
#define STACK_TREE_H

#include<stdio.h>
#include<stdlib.h>
#include"sTree.h"
#define MAX_SIZE 500

typedef struct stt
{
  sTree* s;
  struct stt* next;
}stackTree;

/*
  "Constructeur"
*/

stackTree* createST(sTree* s, stackTree* next);

/*
  Affiche la pile.
 */

void printST(stackTree* st);

/*
  Detruit la pile mais pas les arbres syntaxiques qui s'y trouvent.
*/

void destroyST(stackTree* st);

/*
  Retourne vrai si la pile est vide.
*/

int isEmptyST(stackTree* st);

/*
  Place s au sommet de la pile st.
*/

stackTree* pushST(stackTree* st, sTree* s);

/*
  Retourne le sommet de la pile st
*/

sTree* topST(stackTree* st);

/*
  Detruit le sommet de la pile st.
*/

stackTree* popST(stackTree* st);

/*
  Ajoute au sommet de la pile un arbre syntaxique representant 
  une constante.
*/

stackTree* addConstantST(stackTree* st, int constant);

/*
  Ajoute au sommet de la pile un arbre syntaxique representant 
  la variable.  
*/

stackTree* addVariableST(stackTree* st);

/*
  Ajoute au sommet de la pile un arbre syntaxique representant 
  une operation entre le sous-sommet et le sommet de la pile.  
*/

stackTree* addOperatorST(stackTree* st, int operator);

/*
  Ajoute au sommet de la pile un arbre syntaxique representant 
  le logarithme du sommet de la pile.  
*/

stackTree* addLnST(stackTree* st, int operator);

#endif
